代码随想录算法训练营第二十七天 | 39. 组合总和、40.组合总和II、131.分割回文串

本文主要是介绍代码随想录算法训练营第二十七天 | 39. 组合总和、40.组合总和II、131.分割回文串,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

39. 组合总和

题目链接:https://leetcode.cn/problems/combination-sum/
文档讲解:https://programmercarl.com/0039.%E7%BB%84%E5%90%88%E6%80%BB%E5%92%8C.html
视频讲解:https://www.bilibili.com/video/BV1KT4y1M7HJ

思路

  • 这道题和之前做过的组合区别在于每个数都可以重复使用,在代码中体现为,递归时startIndex的值不用+1。
  • 剪枝优化:先将数组从小到大排序。在递归前判断,如果 sum+candidates[i] > target,就没必要再递归。

代码

未剪枝

class Solution {List<List<Integer>> res = new ArrayList<>();List<Integer> path = new ArrayList<>();public List<List<Integer>> combinationSum(int[] candidates, int target) {backtracking(candidates, target, 0, 0);return res;}public void backtracking(int[] candidates, int target, int sum, int startIndex) {if (sum == target) {res.add(new ArrayList<>(path));return;}    if (sum > target) return; for (int i = startIndex; i < candidates.length && sum + candidates[i] <= target; i++) {path.add(candidates[i]);backtracking(candidates, target, sum + candidates[i], i); // 不用i+1,因为当前节点可以重复被使用path.removeLast();}    }
}

剪枝优化

class Solution {List<List<Integer>> res = new ArrayList<>();List<Integer> path = new ArrayList<>();public List<List<Integer>> combinationSum(int[] candidates, int target) {Arrays.sort(candidates); // 先进行排序backtracking(candidates, target, 0, 0);return res;}public void backtracking(int[] candidates, int target, int sum, int startIndex) {if (sum == target) {res.add(new ArrayList<>(path));return;}    if (sum > target) return;for (int i = startIndex; i < candidates.length && sum + candidates[i] <= target; i++) { // 剪枝path.add(candidates[i]);backtracking(candidates, target, sum + candidates[i], i); // 不用i+1,因为当前节点可以重复被使用path.removeLast();}    }
}

40.组合总和II

题目链接:https://leetcode.cn/problems/combination-sum-ii/
文档讲解:https://programmercarl.com/0040.%E7%BB%84%E5%90%88%E6%80%BB%E5%92%8CII.html
视频讲解:https://www.bilibili.com/video/BV12V4y1V73A

思路

  • 这道题和前面的组合总和的区别在于数组中有重复元素,而结果中要求没有重复数组。这就需要对树的每一层的数进行去重,同层的数不能相等。因为要判断相邻元素是否相等,所以要先排序。
  • 去重方法一(我的思路):不使用标记数组。递归后判断当前数和数组中下一个数是否相等,如果相等就i++,跳过下一个元素。因为可能有多个重复的数,所以这里的判断用while而不是if
for (int i = startIndex; i < candidates.length; i++) {path.add(candidates[i]);backtracking(candidates, target, sum + candidates[i], i + 1);while (i + 1 < candidates.length && candidates[i] == candidates[i + 1]) i++; // 去重path.removeLast()
}

也可以和前一个数比较大小:

for (int i = startIndex; i < candidates.length; i++) {if ( i > start && candidates[i] == candidates[i - 1] ) continue; // 去重path.add(candidates[i]);backtracking(candidates, target, sum + candidates[i], i + 1);path.removeLast();
}
  • 去重方法二(卡哥的思路):使用标记数组。当前数和前一个数相等,并且前一个数的used为false,就需要去重。used之所以是false,说明两个数是同层的。如果uesd为true,说明被使用过,那上一个数就应该是上一层的数,而不是同层的数。
if (i > 0 && candidates[i] == candidates[i - 1] && !used[i - 1]) { // 去重continue;
}

代码

去重方法一

class Solution {List<List<Integer>> res = new ArrayList<>();List<Integer> path = new ArrayList<>();public List<List<Integer>> combinationSum2(int[] candidates, int target) {Arrays.sort(candidates);backtracking(candidates, target, 0, 0);return res;}public void backtracking(int[] candidates, int target, int sum, int startIndex) {if (sum == target) {res.add(new ArrayList<>(path));return;}if (sum > target) return;for (int i = startIndex; i < candidates.length && sum + candidates[i] <= target; i++) { // 剪枝path.add(candidates[i]);backtracking(candidates, target, sum + candidates[i], i + 1);while (i + 1 < candidates.length && candidates[i] == candidates[i + 1]) i++; // 去重path.removeLast();}}
}

去重方法二

class Solution {List<List<Integer>> res = new ArrayList<>();List<Integer> path = new ArrayList<>();boolean[] used;public List<List<Integer>> combinationSum2(int[] candidates, int target) {Arrays.sort(candidates);used = new boolean[candidates.length];Arrays.fill(used, false);backtracking(candidates, target, 0, 0);return res;}public void backtracking(int[] candidates, int target, int sum, int startIndex) {if (sum == target) {res.add(new ArrayList<>(path));return;}if (sum > target) return;for (int i = startIndex; i < candidates.length && sum + candidates[i] <= target; i++) {if (i > 0 && candidates[i] == candidates[i - 1] && !used[i - 1]) { // 去重continue;}path.add(candidates[i]);used[i] = true;backtracking(candidates, target, sum + candidates[i], i + 1);used[i] = false;path.removeLast();}}
}

131.分割回文串

题目链接:https://leetcode.cn/problems/palindrome-partitioning/
文档讲解:https://programmercarl.com/0131.%E5%88%86%E5%89%B2%E5%9B%9E%E6%96%87%E4%B8%B2.html
视频讲解:https://www.bilibili.com/video/BV1c54y1e7k6

思路

  • 切割问题可以抽象为组合问题,每次选取的是切割的点,然后得到中间的一段字符串。所以我们只需要移动确定切割的起点和终点,然后截取他们中间的字符串。
  • 切割问题中递归的终止条件:当startIndex==s.length(),说明已经按照某种方案遍历完字符串,那么就可以提交一组切割方案了。
  • 判断回文串的方法:双指针法,从两端向中间靠拢。

代码

class Solution {List<List<String>> res = new ArrayList<>();List<String> path = new ArrayList<>();public List<List<String>> partition(String s) {backtracking(s, 0);return res;}public void backtracking(String s, int startIndex) {// startIndex控制的是起始位置,如果起始位置已经大于s的大小,说明已经找到了一组分割方案了if (startIndex >= s.length()) {res.add(new ArrayList<>(path));return;}for (int i = startIndex; i < s.length(); i++) {if (isPalindrome(s.substring(startIndex, i + 1))) {path.add(s.substring(startIndex, i + 1));backtracking(s, i + 1);path.removeLast();}}}public boolean isPalindrome(String s) {int left = 0, right = s.length() - 1;while (left < right) {if (s.charAt(left) != s.charAt(right)) return false;left++;right--;}return true;}
}

这篇关于代码随想录算法训练营第二十七天 | 39. 组合总和、40.组合总和II、131.分割回文串的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1027929

相关文章

不懂推荐算法也能设计推荐系统

本文以商业化应用推荐为例,告诉我们不懂推荐算法的产品,也能从产品侧出发, 设计出一款不错的推荐系统。 相信很多新手产品,看到算法二字,多是懵圈的。 什么排序算法、最短路径等都是相对传统的算法(注:传统是指科班出身的产品都会接触过)。但对于推荐算法,多数产品对着网上搜到的资源,都会无从下手。特别当某些推荐算法 和 “AI”扯上关系后,更是加大了理解的难度。 但,不了解推荐算法,就无法做推荐系

康拓展开(hash算法中会用到)

康拓展开是一个全排列到一个自然数的双射(也就是某个全排列与某个自然数一一对应) 公式: X=a[n]*(n-1)!+a[n-1]*(n-2)!+...+a[i]*(i-1)!+...+a[1]*0! 其中,a[i]为整数,并且0<=a[i]<i,1<=i<=n。(a[i]在不同应用中的含义不同); 典型应用: 计算当前排列在所有由小到大全排列中的顺序,也就是说求当前排列是第

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

综合安防管理平台LntonAIServer视频监控汇聚抖动检测算法优势

LntonAIServer视频质量诊断功能中的抖动检测是一个专门针对视频稳定性进行分析的功能。抖动通常是指视频帧之间的不必要运动,这种运动可能是由于摄像机的移动、传输中的错误或编解码问题导致的。抖动检测对于确保视频内容的平滑性和观看体验至关重要。 优势 1. 提高图像质量 - 清晰度提升:减少抖动,提高图像的清晰度和细节表现力,使得监控画面更加真实可信。 - 细节增强:在低光条件下,抖

hdu4869(逆元+求组合数)

//输入n,m,n表示翻牌的次数,m表示牌的数目,求经过n次操作后共有几种状态#include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdlib.h>#includ

【数据结构】——原来排序算法搞懂这些就行,轻松拿捏

前言:快速排序的实现最重要的是找基准值,下面让我们来了解如何实现找基准值 基准值的注释:在快排的过程中,每一次我们要取一个元素作为枢纽值,以这个数字来将序列划分为两部分。 在此我们采用三数取中法,也就是取左端、中间、右端三个数,然后进行排序,将中间数作为枢纽值。 快速排序实现主框架: //快速排序 void QuickSort(int* arr, int left, int rig

csu1328(近似回文串)

题意:求近似回文串的最大长度,串长度为1000。 解题思路:以某点为中心,向左右两边扩展,注意奇偶分开讨论,暴力解即可。时间复杂度O(n^2); 代码如下: #include<iostream>#include<algorithm>#include<stdio.h>#include<math.h>#include<cstring>#include<string>#inclu

活用c4d官方开发文档查询代码

当你问AI助手比如豆包,如何用python禁止掉xpresso标签时候,它会提示到 这时候要用到两个东西。https://developers.maxon.net/论坛搜索和开发文档 比如这里我就在官方找到正确的id描述 然后我就把参数标签换过来

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n